package com.util.crypto_util;

import org.bouncycastle.crypto.engines.SM2Engine;

import cn.hutool.core.util.HexUtil;
import cn.hutool.crypto.SecureUtil;
import cn.hutool.crypto.SmUtil;
import cn.hutool.crypto.asymmetric.KeyType;
import cn.hutool.crypto.asymmetric.SM2;
import cn.hutool.crypto.symmetric.SymmetricCrypto;

public class Crypto {
    private static final String PRIVATE_KEY = "000cbeb1b4cb89580f72ada8d1dd8e39b0453ccc10eb92e725f9c7ec1cda92fb6f";
    private static final String PUBLIC_KEY = "04b239e96ed5298a536f88f1e52c614029dd84cf1a17f3a49fe577df526624c91f4906b82117760e25fe6dc1b44018a810c0e33a16cae9bae20e71a25a7efd08f8";

    /**
     * SM2加密
     *
     * @return 结果
     */
    public static String encryptSM2(String data) {
        SM2 sm2 = SmUtil.sm2(PRIVATE_KEY, PUBLIC_KEY).setMode(SM2Engine.Mode.C1C3C2);
        return sm2.encryptBase64(data, KeyType.PublicKey);
    }

    /**
     * SM4加密
     *
     * @return 结果
     */
    public static String encryptSM4(String key, String data) {
        SymmetricCrypto sm4 = SmUtil.sm4(HexUtil.decodeHex(key));
        return sm4.encryptBase64(data);
    }

    /**
     * SM2解密
     *
     * @return 结果
     */
    public static String decryptSM2() {
        return "";
    }

    /**
     * SM4解密
     *
     * @return 结果
     */
    public static String decryptSM4() {
        return "";
    }


    /**
     * 生成秘钥
     *
     * @param type 秘钥类型
     * @return
     */
    public static String generateKey(String type) {
        switch (type) {
            case "SM4":
                byte[] byteKey = SecureUtil.generateKey("SM4").getEncoded();
                return HexUtil.encodeHexStr(byteKey);
            default:
                break;
        }
        return "";
    }
}
