import 'dart:async';

import 'package:flutter/services.dart';

class CryptoUtil {
  static const MethodChannel _channel = const MethodChannel('crypto_util');

  static Future<String> encryptSM4(String key, String data) async {
    Map<String, String> _params = Map<String, String>();
    _params['key'] = key;
    _params['data'] = data;
    return await _channel.invokeMethod('encryptSM4', _params);
  }

  static Future<String> encryptSM2(String data) async {
    return await _channel.invokeMethod('encryptSM2', data);
  }

  static Future<String> generateKey(String type) async {
    return await _channel.invokeMethod('generateKey', type);
  }
}
